function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { Component } from "react";
import Tip from "./Tip";
import "../style/ContextMenu.css";

class ContextMenu extends Component {
  constructor(...args) {
    super(...args);

    _defineProperty(this, "state", {
      showMenu: false
    });

    _defineProperty(this, "handleContextMenu", e => {
      e.preventDefault();
      this.setState.showMenu = true;
    });

    _defineProperty(this, "handleClick", e => {
      if (this.state.showMenu) {
        this.setState({
          showMenu: false
        });
      }
    });
  }

  componentDidMount() {
    document.addEventListener("click", e => this.handleClick(e));
    document.addEventListener("contextmenu", e => this.handleContextMenu(e));
  }

  componentWillUnmount() {
    // fix Warning: Can't perform a React state update on an unmounted component
    this.setState = (state, callback) => {
      return;
    };

    document.removeEventListener("click", e => this.handleClick(e));
    document.removeEventListener("contextmenu", e => this.handleContextMenu(e));
  }

  render() {
    const {
      showMenu
    } = this.state;
    const {
      onConfirm,
      onOpen,
      clientPosition,
      position
    } = this.props;
    const page = clientPosition && clientPosition.viewer && clientPosition.viewer.getPageView(position.pageNumber - 1).div;
    const topOffset = page && Math.abs(page.getBoundingClientRect().top); // if (showMenu)

    return /*#__PURE__*/React.createElement(Tip, {
      onOpen: onOpen,
      onConfirm: onConfirm,
      style: clientPosition && {
        top: clientPosition.yPos + topOffset + (page && page.offsetTop),
        left: clientPosition.xPos,
        position: "absolute"
      }
    }); // else return null;
  }

}

export default ContextMenu;